Index: /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7885)
+++ /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7886)
@@ -2261,27 +2236,27 @@
                !!----------------------------------------------------------------------
                !!
-               if (fdep1.le.hmld(ji,jj)) then
+               if (fdep1(ji,jj).le.hmld(ji,jj)) then
                   !! this level is entirely in the mixed layer
                   fq0 = 1.0
-               elseif (fdep.ge.hmld(ji,jj)) then
+               elseif (fsdepw(ji,jj,jk).ge.hmld(ji,jj)) then
                   !! this level is entirely below the mixed layer
                   fq0 = 0.0
                else
                   !! this level straddles the mixed layer
-                  fq0 = (hmld(ji,jj) - fdep) / fthk
+                  fq0 = (hmld(ji,jj) - fsdepw(ji,jj,jk)) / fse3t(ji,jj,jk)
                endif
                !!
-               fprn_ml(ji,jj) = fprn_ml(ji,jj) + (fprn * zphn * fthk * fq0)
-               fprd_ml(ji,jj) = fprd_ml(ji,jj) + (fprd * zphd * fthk * fq0)
+               fprn_ml(ji,jj) = fprn_ml(ji,jj) + (fprn(ji,jj) * zphn(ji,jj) * fse3t(ji,jj,jk) * fq0)
+               fprd_ml(ji,jj) = fprd_ml(ji,jj) + (fprd(ji,jj) * zphd(ji,jj) * fse3t(ji,jj,jk) * fq0)
                
                !!----------------------------------------------------------------------
                !! Vertical Integral --
                !!----------------------------------------------------------------------
-               ftot_pn(ji,jj)  = ftot_pn(ji,jj)  + (zphn * fthk)   !! vertical integral non-diatom phytoplankton
-               ftot_pd(ji,jj)  = ftot_pd(ji,jj)  + (zphd * fthk)   !! vertical integral diatom phytoplankton
-               ftot_zmi(ji,jj) = ftot_zmi(ji,jj) + (zzmi * fthk)   !! vertical integral microzooplankton
-               ftot_zme(ji,jj) = ftot_zme(ji,jj) + (zzme * fthk)   !! vertical integral mesozooplankton
-               ftot_det(ji,jj) = ftot_det(ji,jj) + (zdet * fthk)   !! vertical integral slow detritus, nitrogen
-               ftot_dtc(ji,jj) = ftot_dtc(ji,jj) + (zdtc * fthk)   !! vertical integral slow detritus, carbon
+               ftot_pn(ji,jj)  = ftot_pn(ji,jj)  + (zphn(ji,jj) * fse3t(ji,jj,jk))   !! vertical integral non-diatom phytoplankton
+               ftot_pd(ji,jj)  = ftot_pd(ji,jj)  + (zphd(ji,jj) * fse3t(ji,jj,jk))   !! vertical integral diatom phytoplankton
+               ftot_zmi(ji,jj) = ftot_zmi(ji,jj) + (zzmi(ji,jj) * fse3t(ji,jj,jk))   !! vertical integral microzooplankton
+               ftot_zme(ji,jj) = ftot_zme(ji,jj) + (zzme(ji,jj) * fse3t(ji,jj,jk))   !! vertical integral mesozooplankton
+               ftot_det(ji,jj) = ftot_det(ji,jj) + (zdet(ji,jj) * fse3t(ji,jj,jk))   !! vertical integral slow detritus, nitrogen
+               ftot_dtc(ji,jj) = ftot_dtc(ji,jj) + (zdtc(ji,jj) * fse3t(ji,jj,jk))   !! vertical integral slow detritus, carbon
                
                !!----------------------------------------------------------------------
@@ -2289,7 +2264,7 @@
                !!----------------------------------------------------------------------
                !!
-               !! frn = (xthetam / fthetan) * (fprn / (fthetan * xpar(ji,jj,jk)))
-               !! frd = (xthetam / fthetad) * (fprd / (fthetad * xpar(ji,jj,jk)))
-               frn = (xthetam * fchn * fnln * ffln       ) / (fthetan + tiny(fthetan))
+               !! frn(ji,jj) = (xthetam / fthetan(ji,jj)) * (fprn(ji,jj) / (fthetan(ji,jj) * xpar(ji,jj,jk)))
+               !! frd(ji,jj) = (xthetam / fthetad(ji,jj)) * (fprd(ji,jj) / (fthetad(ji,jj) * xpar(ji,jj,jk)))
+               frn(ji,jj) = (xthetam * fchn(ji,jj) * fnln(ji,jj) * ffln(ji,jj)       ) / (fthetan(ji,jj) + tiny(fthetan(ji,jj)))
                !! AXY (12/05/09): there's potentially a problem here; fsld, silicic acid 
                !!   limitation, is used in the following line to regulate chlorophyll 
@@ -2297,8 +2272,8 @@
                !!   of biomass growth; the Mongin term term used in growth is more complex
                !!   than the simple multiplicative function used below
-               !! frd = (xthetam * fchd * fnld * ffld * fsld) / (fthetad + tiny(fthetad))
+               !! frd(ji,jj) = (xthetam * fchd(ji,jj) * fnld(ji,jj) * ffld(ji,jj) * fsld(ji,jj)) / (fthetad(ji,jj) + tiny(fthetad(ji,jj)))
                !! AXY (12/05/09): this replacement line uses the new variable, fsld2, to
                !!   regulate chlorophyll growth
-               frd = (xthetamd * fchd * fnld * ffld * fsld2) / (fthetad + tiny(fthetad))
+               frd(ji,jj) = (xthetamd * fchd(ji,jj) * fnld(ji,jj) * ffld(ji,jj) * fsld2(ji,jj)) / (fthetad(ji,jj) + tiny(fthetad(ji,jj)))
 
 # if defined key_debug_medusa
@@ -2306,8 +2281,8 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fthetan(',jk,') = ', fthetan
-                  IF (lwp) write (numout,*) 'fthetad(',jk,') = ', fthetad
-                  IF (lwp) write (numout,*) 'frn(',jk,')     = ', frn
-                  IF (lwp) write (numout,*) 'frd(',jk,')     = ', frd
+                  IF (lwp) write (numout,*) 'fthetan(',jk,') = ', fthetan(ji,jj)
+                  IF (lwp) write (numout,*) 'fthetad(',jk,') = ', fthetad(ji,jj)
+                  IF (lwp) write (numout,*) 'frn(',jk,')     = ', frn(ji,jj)
+                  IF (lwp) write (numout,*) 'frd(',jk,')     = ', frd(ji,jj)
                endif
 # endif
@@ -2329,37 +2304,37 @@
                !!----------------------------------------------------------------------
                !!
-               fmi1    = (xkmi * xkmi) + (xpmipn * zphn * zphn) + (xpmid * zdet * zdet)
-               fmi     = xgmi * zzmi / fmi1
-               fgmipn  = fmi * xpmipn * zphn * zphn   !! grazing on non-diatoms
-               fgmid   = fmi * xpmid  * zdet * zdet   !! grazing on detrital nitrogen
+               fmi1(ji,jj)    = (xkmi * xkmi) + (xpmipn * zphn(ji,jj) * zphn(ji,jj)) + (xpmid * zdet(ji,jj) * zdet(ji,jj))
+               fmi(ji,jj)     = xgmi * zzmi(ji,jj) / fmi1(ji,jj)
+               fgmipn(ji,jj)  = fmi(ji,jj) * xpmipn * zphn(ji,jj) * zphn(ji,jj)   !! grazing on non-diatoms
+               fgmid(ji,jj)   = fmi(ji,jj) * xpmid  * zdet(ji,jj) * zdet(ji,jj)   !! grazing on detrital nitrogen
 # if defined key_roam
-               fgmidc  = rsmall !acc
-               IF ( zdet .GT. rsmall ) fgmidc  = (zdtc / (zdet + tiny(zdet))) * fgmid  !! grazing on detrital carbon
+               fgmidc(ji,jj)  = rsmall !acc
+               IF ( zdet(ji,jj) .GT. rsmall ) fgmidc(ji,jj)  = (zdtc(ji,jj) / (zdet(ji,jj) + tiny(zdet(ji,jj)))) * fgmid(ji,jj)  !! grazing on detrital carbon
 # else
                !! AXY (26/11/08): implicit detrital carbon change
-               fgmidc  = xthetad * fgmid              !! grazing on detrital carbon
+               fgmidc(ji,jj)  = xthetad * fgmid(ji,jj)              !! grazing on detrital carbon
 # endif
                !!
                !! which translates to these incoming N and C fluxes
-               finmi   = (1.0 - xphi) * (fgmipn + fgmid)
-               ficmi   = (1.0 - xphi) * ((xthetapn * fgmipn) + fgmidc)
+               finmi(ji,jj)   = (1.0 - xphi) * (fgmipn(ji,jj) + fgmid(ji,jj))
+               ficmi(ji,jj)   = (1.0 - xphi) * ((xthetapn * fgmipn(ji,jj)) + fgmidc(ji,jj))
                !!
                !! the ideal food C:N ratio for microzooplankton
                !! xbetan = 0.77; xthetaz = 5.625; xbetac = 0.64; xkc = 0.80
-               fstarmi = (xbetan * xthetazmi) / (xbetac * xkc)
+               fstarmi(ji,jj) = (xbetan * xthetazmi) / (xbetac * xkc)
                !!
                !! process these to determine proportioning of grazed N and C
                !! (since there is no explicit consideration of respiration,
                !! only growth and excretion are calculated here)
-               fmith   = (ficmi / (finmi + tiny(finmi)))
-               if (fmith.ge.fstarmi) then
-                  fmigrow = xbetan * finmi
-                  fmiexcr = 0.0
+               fmith(ji,jj)   = (ficmi(ji,jj) / (finmi(ji,jj) + tiny(finmi(ji,jj))))
+               if (fmith(ji,jj).ge.fstarmi(ji,jj)) then
+                  fmigrow(ji,jj) = xbetan * finmi(ji,jj)
+                  fmiexcr(ji,jj) = 0.0
                else
-                  fmigrow = (xbetac * xkc * ficmi) / xthetazmi
-                  fmiexcr = ficmi * ((xbetan / (fmith + tiny(fmith))) - ((xbetac * xkc) / xthetazmi))
+                  fmigrow(ji,jj) = (xbetac * xkc * ficmi(ji,jj)) / xthetazmi
+                  fmiexcr(ji,jj) = ficmi(ji,jj) * ((xbetan / (fmith(ji,jj) + tiny(fmith(ji,jj)))) - ((xbetac * xkc) / xthetazmi))
                endif
 # if defined key_roam
-               fmiresp = (xbetac * ficmi) - (xthetazmi * fmigrow)
+               fmiresp(ji,jj) = (xbetac * ficmi(ji,jj)) - (xthetazmi * fmigrow(ji,jj))
 # endif
 
@@ -2368,17 +2343,17 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fmi1(',jk,')    = ', fmi1
-                  IF (lwp) write (numout,*) 'fmi(',jk,')     = ', fmi
-                  IF (lwp) write (numout,*) 'fgmipn(',jk,')  = ', fgmipn
-                  IF (lwp) write (numout,*) 'fgmid(',jk,')   = ', fgmid
-                  IF (lwp) write (numout,*) 'fgmidc(',jk,')  = ', fgmidc
-                  IF (lwp) write (numout,*) 'finmi(',jk,')   = ', finmi
-                  IF (lwp) write (numout,*) 'ficmi(',jk,')   = ', ficmi
-                  IF (lwp) write (numout,*) 'fstarmi(',jk,') = ', fstarmi
-                  IF (lwp) write (numout,*) 'fmith(',jk,')   = ', fmith
-                  IF (lwp) write (numout,*) 'fmigrow(',jk,') = ', fmigrow
-                  IF (lwp) write (numout,*) 'fmiexcr(',jk,') = ', fmiexcr
+                  IF (lwp) write (numout,*) 'fmi1(',jk,')    = ', fmi1(ji,jj)
+                  IF (lwp) write (numout,*) 'fmi(',jk,')     = ', fmi(ji,jj)
+                  IF (lwp) write (numout,*) 'fgmipn(',jk,')  = ', fgmipn(ji,jj)
+                  IF (lwp) write (numout,*) 'fgmid(',jk,')   = ', fgmid(ji,jj)
+                  IF (lwp) write (numout,*) 'fgmidc(',jk,')  = ', fgmidc(ji,jj)
+                  IF (lwp) write (numout,*) 'finmi(',jk,')   = ', finmi(ji,jj)
+                  IF (lwp) write (numout,*) 'ficmi(',jk,')   = ', ficmi(ji,jj)
+                  IF (lwp) write (numout,*) 'fstarmi(',jk,') = ', fstarmi(ji,jj)
+                  IF (lwp) write (numout,*) 'fmith(',jk,')   = ', fmith(ji,jj)
+                  IF (lwp) write (numout,*) 'fmigrow(',jk,') = ', fmigrow(ji,jj)
+                  IF (lwp) write (numout,*) 'fmiexcr(',jk,') = ', fmiexcr(ji,jj)
 #  if defined key_roam
-                  IF (lwp) write (numout,*) 'fmiresp(',jk,') = ', fmiresp
+                  IF (lwp) write (numout,*) 'fmiresp(',jk,') = ', fmiresp(ji,jj)
 #  endif
                endif
@@ -2389,42 +2364,42 @@
                !!----------------------------------------------------------------------
                !!
-               fme1    = (xkme * xkme) + (xpmepn * zphn * zphn) + (xpmepd * zphd * zphd) + & 
-                         (xpmezmi * zzmi * zzmi) + (xpmed * zdet * zdet)
-               fme     = xgme * zzme / fme1
-               fgmepn  = fme * xpmepn  * zphn * zphn  !! grazing on non-diatoms
-               fgmepd  = fme * xpmepd  * zphd * zphd  !! grazing on diatoms
-               fgmepds = fsin * fgmepd                !! grazing on diatom silicon
-               fgmezmi = fme * xpmezmi * zzmi * zzmi  !! grazing on microzooplankton
-               fgmed   = fme * xpmed   * zdet * zdet  !! grazing on detrital nitrogen
+               fme1(ji,jj)    = (xkme * xkme) + (xpmepn * zphn(ji,jj) * zphn(ji,jj)) + (xpmepd * zphd(ji,jj) * zphd(ji,jj)) + & 
+                         (xpmezmi * zzmi(ji,jj) * zzmi(ji,jj)) + (xpmed * zdet(ji,jj) * zdet(ji,jj))
+               fme(ji,jj)     = xgme * zzme(ji,jj) / fme1(ji,jj)
+               fgmepn(ji,jj)  = fme(ji,jj) * xpmepn  * zphn(ji,jj) * zphn(ji,jj)  !! grazing on non-diatoms
+               fgmepd(ji,jj)  = fme(ji,jj) * xpmepd  * zphd(ji,jj) * zphd(ji,jj)  !! grazing on diatoms
+               fgmepds(ji,jj) = fsin(ji,jj) * fgmepd(ji,jj)                !! grazing on diatom silicon
+               fgmezmi(ji,jj) = fme(ji,jj) * xpmezmi * zzmi(ji,jj) * zzmi(ji,jj)  !! grazing on microzooplankton
+               fgmed(ji,jj)   = fme(ji,jj) * xpmed   * zdet(ji,jj) * zdet(ji,jj)  !! grazing on detrital nitrogen
 # if defined key_roam
-               fgmedc  = rsmall !acc
-               IF ( zdet .GT. rsmall ) fgmedc  = (zdtc / (zdet + tiny(zdet))) * fgmed  !! grazing on detrital carbon
+               fgmedc(ji,jj)  = rsmall !acc
+               IF ( zdet(ji,jj) .GT. rsmall ) fgmedc(ji,jj)  = (zdtc(ji,jj) / (zdet(ji,jj) + tiny(zdet(ji,jj)))) * fgmed(ji,jj)  !! grazing on detrital carbon
 # else
                !! AXY (26/11/08): implicit detrital carbon change
-               fgmedc  = xthetad * fgmed              !! grazing on detrital carbon
+               fgmedc(ji,jj)  = xthetad * fgmed(ji,jj)              !! grazing on detrital carbon
 # endif
                !!
                !! which translates to these incoming N and C fluxes
-               finme   = (1.0 - xphi) * (fgmepn + fgmepd + fgmezmi + fgmed)
-               ficme   = (1.0 - xphi) * ((xthetapn * fgmepn) + (xthetapd * fgmepd) + &
-                        (xthetazmi * fgmezmi) + fgmedc)
+               finme(ji,jj)   = (1.0 - xphi) * (fgmepn(ji,jj) + fgmepd(ji,jj) + fgmezmi(ji,jj) + fgmed(ji,jj))
+               ficme(ji,jj)   = (1.0 - xphi) * ((xthetapn * fgmepn(ji,jj)) + (xthetapd * fgmepd(ji,jj)) + &
+                        (xthetazmi * fgmezmi(ji,jj)) + fgmedc(ji,jj))
                !!
                !! the ideal food C:N ratio for mesozooplankton
                !! xbetan = 0.77; xthetaz = 5.625; xbetac = 0.64; xkc = 0.80
-               fstarme = (xbetan * xthetazme) / (xbetac * xkc)
+               fstarme(ji,jj) = (xbetan * xthetazme) / (xbetac * xkc)
                !!
                !! process these to determine proportioning of grazed N and C
                !! (since there is no explicit consideration of respiration,
                !! only growth and excretion are calculated here)
-               fmeth   = (ficme / (finme + tiny(finme)))
-               if (fmeth.ge.fstarme) then
-                  fmegrow = xbetan * finme
-                  fmeexcr = 0.0
+               fmeth(ji,jj)   = (ficme(ji,jj) / (finme(ji,jj) + tiny(finme(ji,jj))))
+               if (fmeth(ji,jj).ge.fstarme(ji,jj)) then
+                  fmegrow(ji,jj) = xbetan * finme(ji,jj)
+                  fmeexcr(ji,jj) = 0.0
                else
-                  fmegrow = (xbetac * xkc * ficme) / xthetazme
-                  fmeexcr = ficme * ((xbetan / (fmeth + tiny(fmeth))) - ((xbetac * xkc) / xthetazme))
+                  fmegrow(ji,jj) = (xbetac * xkc * ficme(ji,jj)) / xthetazme
+                  fmeexcr(ji,jj) = ficme(ji,jj) * ((xbetan / (fmeth(ji,jj) + tiny(fmeth(ji,jj)))) - ((xbetac * xkc) / xthetazme))
                endif
 # if defined key_roam
-               fmeresp = (xbetac * ficme) - (xthetazme * fmegrow)
+               fmeresp(ji,jj) = (xbetac * ficme(ji,jj)) - (xthetazme * fmegrow(ji,jj))
 # endif
 
@@ -2433,32 +2408,32 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fme1(',jk,')    = ', fme1
-                  IF (lwp) write (numout,*) 'fme(',jk,')     = ', fme
-                  IF (lwp) write (numout,*) 'fgmepn(',jk,')  = ', fgmepn
-                  IF (lwp) write (numout,*) 'fgmepd(',jk,')  = ', fgmepd
-                  IF (lwp) write (numout,*) 'fgmepds(',jk,') = ', fgmepds
-                  IF (lwp) write (numout,*) 'fgmezmi(',jk,') = ', fgmezmi
-                  IF (lwp) write (numout,*) 'fgmed(',jk,')   = ', fgmed
-                  IF (lwp) write (numout,*) 'fgmedc(',jk,')  = ', fgmedc
-                  IF (lwp) write (numout,*) 'finme(',jk,')   = ', finme
-                  IF (lwp) write (numout,*) 'ficme(',jk,')   = ', ficme
-                  IF (lwp) write (numout,*) 'fstarme(',jk,') = ', fstarme
-                  IF (lwp) write (numout,*) 'fmeth(',jk,')   = ', fmeth
-                  IF (lwp) write (numout,*) 'fmegrow(',jk,') = ', fmegrow
-                  IF (lwp) write (numout,*) 'fmeexcr(',jk,') = ', fmeexcr
+                  IF (lwp) write (numout,*) 'fme1(',jk,')    = ', fme1(ji,jj)
+                  IF (lwp) write (numout,*) 'fme(',jk,')     = ', fme(ji,jj)
+                  IF (lwp) write (numout,*) 'fgmepn(',jk,')  = ', fgmepn(ji,jj)
+                  IF (lwp) write (numout,*) 'fgmepd(',jk,')  = ', fgmepd(ji,jj)
+                  IF (lwp) write (numout,*) 'fgmepds(',jk,') = ', fgmepds(ji,jj)
+                  IF (lwp) write (numout,*) 'fgmezmi(',jk,') = ', fgmezmi(ji,jj)
+                  IF (lwp) write (numout,*) 'fgmed(',jk,')   = ', fgmed(ji,jj)
+                  IF (lwp) write (numout,*) 'fgmedc(',jk,')  = ', fgmedc(ji,jj)
+                  IF (lwp) write (numout,*) 'finme(',jk,')   = ', finme(ji,jj)
+                  IF (lwp) write (numout,*) 'ficme(',jk,')   = ', ficme(ji,jj)
+                  IF (lwp) write (numout,*) 'fstarme(',jk,') = ', fstarme(ji,jj)
+                  IF (lwp) write (numout,*) 'fmeth(',jk,')   = ', fmeth(ji,jj)
+                  IF (lwp) write (numout,*) 'fmegrow(',jk,') = ', fmegrow(ji,jj)
+                  IF (lwp) write (numout,*) 'fmeexcr(',jk,') = ', fmeexcr(ji,jj)
 #  if defined key_roam
-                  IF (lwp) write (numout,*) 'fmeresp(',jk,') = ', fmeresp
+                  IF (lwp) write (numout,*) 'fmeresp(',jk,') = ', fmeresp(ji,jj)
 #  endif
                endif
 # endif
 
-               fzmi_i(ji,jj)  = fzmi_i(ji,jj)  + fthk * (  &
-                  fgmipn + fgmid )
-               fzmi_o(ji,jj)  = fzmi_o(ji,jj)  + fthk * (  &
-                  fmigrow + (xphi * (fgmipn + fgmid)) + fmiexcr + ((1.0 - xbetan) * finmi) )
-               fzme_i(ji,jj)  = fzme_i(ji,jj)  + fthk * (  &
-                  fgmepn + fgmepd + fgmezmi + fgmed )
-               fzme_o(ji,jj)  = fzme_o(ji,jj)  + fthk * (  &
-                  fmegrow + (xphi * (fgmepn + fgmepd + fgmezmi + fgmed)) + fmeexcr + ((1.0 - xbetan) * finme) )
+               fzmi_i(ji,jj)  = fzmi_i(ji,jj)  + fse3t(ji,jj,jk) * (  &
+                  fgmipn(ji,jj) + fgmid(ji,jj) )
+               fzmi_o(ji,jj)  = fzmi_o(ji,jj)  + fse3t(ji,jj,jk) * (  &
+                  fmigrow(ji,jj) + (xphi * (fgmipn(ji,jj) + fgmid(ji,jj))) + fmiexcr(ji,jj) + ((1.0 - xbetan) * finmi(ji,jj)) )
+               fzme_i(ji,jj)  = fzme_i(ji,jj)  + fse3t(ji,jj,jk) * (  &
+                  fgmepn(ji,jj) + fgmepd(ji,jj) + fgmezmi(ji,jj) + fgmed(ji,jj) )
+               fzme_o(ji,jj)  = fzme_o(ji,jj)  + fse3t(ji,jj,jk) * (  &
+                  fmegrow(ji,jj) + (xphi * (fgmepn(ji,jj) + fgmepd(ji,jj) + fgmezmi(ji,jj) + fgmed(ji,jj))) + fmeexcr(ji,jj) + ((1.0 - xbetan) * finme(ji,jj)) )
 
                !!----------------------------------------------------------------------
@@ -2467,9 +2442,9 @@
                !!----------------------------------------------------------------------
                !!
-               fdpn2  = xmetapn  * zphn
-               fdpd2  = xmetapd  * zphd
-               fdpds2 = xmetapd  * zpds
-               fdzmi2 = xmetazmi * zzmi
-               fdzme2 = xmetazme * zzme
+               fdpn2(ji,jj)  = xmetapn  * zphn(ji,jj)
+               fdpd2(ji,jj)  = xmetapd  * zphd(ji,jj)
+               fdpds2(ji,jj) = xmetapd  * zpds(ji,jj)
+               fdzmi2(ji,jj) = xmetazmi * zzmi(ji,jj)
+               fdzme2(ji,jj) = xmetazme * zzme(ji,jj)
 
                !!----------------------------------------------------------------------
@@ -2480,35 +2455,35 @@
                !!
                !! non-diatom phytoplankton
-               if (jmpn.eq.1) fdpn = xmpn * zphn               !! linear
-               if (jmpn.eq.2) fdpn = xmpn * zphn * zphn        !! quadratic
-               if (jmpn.eq.3) fdpn = xmpn * zphn * &           !! hyperbolic
-                  (zphn / (xkphn + zphn))
-               if (jmpn.eq.4) fdpn = xmpn * zphn * &           !! sigmoid
-                  ((zphn * zphn) / (xkphn + (zphn * zphn)))
+               if (jmpn.eq.1) fdpn(ji,jj) = xmpn * zphn(ji,jj)               !! linear
+               if (jmpn.eq.2) fdpn(ji,jj) = xmpn * zphn(ji,jj) * zphn(ji,jj)        !! quadratic
+               if (jmpn.eq.3) fdpn(ji,jj) = xmpn * zphn(ji,jj) * &           !! hyperbolic
+                  (zphn(ji,jj) / (xkphn + zphn(ji,jj)))
+               if (jmpn.eq.4) fdpn(ji,jj) = xmpn * zphn(ji,jj) * &           !! sigmoid
+                  ((zphn(ji,jj) * zphn(ji,jj)) / (xkphn + (zphn(ji,jj) * zphn(ji,jj))))
                !!
                !! diatom phytoplankton
-               if (jmpd.eq.1) fdpd = xmpd * zphd               !! linear
-               if (jmpd.eq.2) fdpd = xmpd * zphd * zphd        !! quadratic
-               if (jmpd.eq.3) fdpd = xmpd * zphd * &           !! hyperbolic
-                  (zphd / (xkphd + zphd))
-               if (jmpd.eq.4) fdpd = xmpd * zphd * &           !! sigmoid
-                  ((zphd * zphd) / (xkphd + (zphd * zphd)))
-               fdpds = fdpd * fsin
+               if (jmpd.eq.1) fdpd(ji,jj) = xmpd * zphd(ji,jj)               !! linear
+               if (jmpd.eq.2) fdpd(ji,jj) = xmpd * zphd(ji,jj) * zphd(ji,jj)        !! quadratic
+               if (jmpd.eq.3) fdpd(ji,jj) = xmpd * zphd(ji,jj) * &           !! hyperbolic
+                  (zphd(ji,jj) / (xkphd + zphd(ji,jj)))
+               if (jmpd.eq.4) fdpd(ji,jj) = xmpd * zphd(ji,jj) * &           !! sigmoid
+                  ((zphd(ji,jj) * zphd(ji,jj)) / (xkphd + (zphd(ji,jj) * zphd(ji,jj))))
+               fdpds(ji,jj) = fdpd(ji,jj) * fsin(ji,jj)
                !!
                !! microzooplankton
-               if (jmzmi.eq.1) fdzmi = xmzmi * zzmi            !! linear
-               if (jmzmi.eq.2) fdzmi = xmzmi * zzmi * zzmi     !! quadratic
-               if (jmzmi.eq.3) fdzmi = xmzmi * zzmi * &        !! hyperbolic
-                  (zzmi / (xkzmi + zzmi))
-               if (jmzmi.eq.4) fdzmi = xmzmi * zzmi * &        !! sigmoid
-                  ((zzmi * zzmi) / (xkzmi + (zzmi * zzmi)))
+               if (jmzmi.eq.1) fdzmi(ji,jj) = xmzmi * zzmi(ji,jj)            !! linear
+               if (jmzmi.eq.2) fdzmi(ji,jj) = xmzmi * zzmi(ji,jj) * zzmi(ji,jj)     !! quadratic
+               if (jmzmi.eq.3) fdzmi(ji,jj) = xmzmi * zzmi(ji,jj) * &        !! hyperbolic
+                  (zzmi(ji,jj) / (xkzmi + zzmi(ji,jj)))
+               if (jmzmi.eq.4) fdzmi(ji,jj) = xmzmi * zzmi(ji,jj) * &        !! sigmoid
+                  ((zzmi(ji,jj) * zzmi(ji,jj)) / (xkzmi + (zzmi(ji,jj) * zzmi(ji,jj))))
                !!
                !! mesozooplankton
-               if (jmzme.eq.1) fdzme = xmzme * zzme            !! linear
-               if (jmzme.eq.2) fdzme = xmzme * zzme * zzme     !! quadratic
-               if (jmzme.eq.3) fdzme = xmzme * zzme * &        !! hyperbolic
-                  (zzme / (xkzme + zzme))
-               if (jmzme.eq.4) fdzme = xmzme * zzme * &        !! sigmoid
-                  ((zzme * zzme) / (xkzme + (zzme * zzme)))
+               if (jmzme.eq.1) fdzme(ji,jj) = xmzme * zzme(ji,jj)            !! linear
+               if (jmzme.eq.2) fdzme(ji,jj) = xmzme * zzme(ji,jj) * zzme(ji,jj)     !! quadratic
+               if (jmzme.eq.3) fdzme(ji,jj) = xmzme * zzme(ji,jj) * &        !! hyperbolic
+                  (zzme(ji,jj) / (xkzme + zzme(ji,jj)))
+               if (jmzme.eq.4) fdzme(ji,jj) = xmzme * zzme(ji,jj) * &        !! sigmoid
+                  ((zzme(ji,jj) * zzme(ji,jj)) / (xkzme + (zzme(ji,jj) * zzme(ji,jj))))
 
                !!----------------------------------------------------------------------
@@ -2519,28 +2494,28 @@
                if (jmd.eq.1) then
                   !! temperature-dependent
-                  fdd  = xmd  * fun_T * zdet
+                  fdd(ji,jj)  = xmd  * fun_T(ji,jj) * zdet(ji,jj)
 # if defined key_roam
-                  fddc = xmdc * fun_T * zdtc
+                  fddc(ji,jj) = xmdc * fun_T(ji,jj) * zdtc(ji,jj)
 # endif
                elseif (jmd.eq.2) then
                   !! AXY (16/05/13): add in Q10-based parameterisation (def in nmlst)
                   !! temperature-dependent
-                  fdd  = xmd  * fun_Q10 * zdet
+                  fdd(ji,jj)  = xmd  * fun_Q10(ji,jj) * zdet(ji,jj)
 #if defined key_roam
-                  fddc = xmdc * fun_Q10 * zdtc
+                  fddc(ji,jj) = xmdc * fun_Q10(ji,jj) * zdtc(ji,jj)
 #endif
                else
                   !! temperature-independent
-                  fdd  = xmd  * zdet
+                  fdd(ji,jj)  = xmd  * zdet(ji,jj)
 # if defined key_roam
-                  fddc = xmdc * zdtc
+                  fddc(ji,jj) = xmdc * zdtc(ji,jj)
 # endif
                endif
                !!
                !! AXY (22/07/09): accelerate detrital remineralisation in the bottom box
-               if ((jk.eq.jmbathy) .and. jsfd.eq.1) then
-                  fdd  = 1.0  * zdet
+               if ((jk.eq.mbathy(ji,jj)) .and. jsfd.eq.1) then
+                  fdd(ji,jj)  = 1.0  * zdet(ji,jj)
 # if defined key_roam
-                  fddc = 1.0  * zdtc
+                  fddc(ji,jj) = 1.0  * zdtc(ji,jj)
 # endif
                endif
@@ -2550,17 +2525,17 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'fdpn2(',jk,') = ', fdpn2
-                  IF (lwp) write (numout,*) 'fdpd2(',jk,') = ', fdpd2
-                  IF (lwp) write (numout,*) 'fdpds2(',jk,')= ', fdpds2
-                  IF (lwp) write (numout,*) 'fdzmi2(',jk,')= ', fdzmi2
-                  IF (lwp) write (numout,*) 'fdzme2(',jk,')= ', fdzme2
-                  IF (lwp) write (numout,*) 'fdpn(',jk,')  = ', fdpn
-                  IF (lwp) write (numout,*) 'fdpd(',jk,')  = ', fdpd
-                  IF (lwp) write (numout,*) 'fdpds(',jk,') = ', fdpds
-                  IF (lwp) write (numout,*) 'fdzmi(',jk,') = ', fdzmi
-                  IF (lwp) write (numout,*) 'fdzme(',jk,') = ', fdzme
-                  IF (lwp) write (numout,*) 'fdd(',jk,')   = ', fdd
+                  IF (lwp) write (numout,*) 'fdpn2(',jk,') = ', fdpn2(ji,jj)
+                  IF (lwp) write (numout,*) 'fdpd2(',jk,') = ', fdpd2(ji,jj)
+                  IF (lwp) write (numout,*) 'fdpds2(',jk,')= ', fdpds2(ji,jj)
+                  IF (lwp) write (numout,*) 'fdzmi2(',jk,')= ', fdzmi2(ji,jj)
+                  IF (lwp) write (numout,*) 'fdzme2(',jk,')= ', fdzme2(ji,jj)
+                  IF (lwp) write (numout,*) 'fdpn(',jk,')  = ', fdpn(ji,jj)
+                  IF (lwp) write (numout,*) 'fdpd(',jk,')  = ', fdpd(ji,jj)
+                  IF (lwp) write (numout,*) 'fdpds(',jk,') = ', fdpds(ji,jj)
+                  IF (lwp) write (numout,*) 'fdzmi(',jk,') = ', fdzmi(ji,jj)
+                  IF (lwp) write (numout,*) 'fdzme(',jk,') = ', fdzme(ji,jj)
+                  IF (lwp) write (numout,*) 'fdd(',jk,')   = ', fdd(ji,jj)
 #  if defined key_roam
-                  IF (lwp) write (numout,*) 'fddc(',jk,')  = ', fddc
+                  IF (lwp) write (numout,*) 'fddc(',jk,')  = ', fddc(ji,jj)
 #  endif
                endif
@@ -2573,13 +2548,13 @@
                !!----------------------------------------------------------------------
                !!
-               if ((jk.eq.jmbathy) .and. jorgben.eq.1) then
+               if ((jk.eq.mbathy(ji,jj)) .and. jorgben.eq.1) then
                   !! this is the BOTTOM OCEAN BOX -> into the benthic pool!
                   !!
-                  f_sbenin_n(ji,jj)  = (zdet * vsed * 86400.)
-                  f_sbenin_fe(ji,jj) = (zdet * vsed * 86400. * xrfn)
+                  f_sbenin_n(ji,jj)  = (zdet(ji,jj) * vsed * 86400.)
+                  f_sbenin_fe(ji,jj) = (zdet(ji,jj) * vsed * 86400. * xrfn)
 # if defined key_roam
-                  f_sbenin_c(ji,jj)  = (zdtc * vsed * 86400.)
+                  f_sbenin_c(ji,jj)  = (zdtc(ji,jj) * vsed * 86400.)
 # else
-                  f_sbenin_c(ji,jj)  = (zdet * vsed * 86400. * xthetad)
+                  f_sbenin_c(ji,jj)  = (zdet(ji,jj) * vsed * 86400. * xthetad)
 # endif
                endif
@@ -2594,5 +2569,5 @@
                !!
                !! total iron concentration (mmol Fe / m3 -> umol Fe / m3)
-               xFeT        = zfer * 1.e3
+               xFeT        = zfer(ji,jj) * 1.e3
                !!
                !! calculate fractionation (based on Diat-HadOCC; in turn based on Parekh et al., 2004)
@@ -2608,5 +2583,5 @@
                !! "free" iron concentration (and convert to mmol Fe / m3)
                xFeF        = (xFeT - xFeL) * 1.e-3
-               xFree(ji,jj)= xFeF / (zfer + tiny(zfer))
+               xFree(ji,jj)= xFeF / (zfer(ji,jj) + tiny(zfer(ji,jj)))
                !!
                !! scavenging of iron (multiple schemes); I'm only really happy with the 
@@ -2621,5 +2596,5 @@
                   !!----------------------------------------------------------------------
                   !!
-                  ffescav     = xk_sc_Fe * xFeF                     ! = mmol/m3/d
+                  ffescav(ji,jj)     = xk_sc_Fe * xFeF                     ! = mmol/m3/d
                   !!
                   !!----------------------------------------------------------------------
@@ -2652,5 +2627,5 @@
                   !! scale of 1 day; seems reasonable to me ... (famous last words)
                   !!
-                  ffescav     = ffescav + fdeltaFe                  ! = mmol/m3/d
+                  ffescav(ji,jj)     = ffescav(ji,jj) + fdeltaFe                  ! = mmol/m3/d
                   !!
 # if defined key_deep_fe_fix
@@ -2670,6 +2645,6 @@
                   !! justifying this in a paper though!
                   !!
-                  if ((fdep.gt.1000.) .and. (xFeT.lt.0.5)) then
-                     ffescav = 0.
+                  if ((fsdepw(ji,jj,jk).gt.1000.) .and. (xFeT.lt.0.5)) then
+                     ffescav(ji,jj) = 0.
                   endif
 # endif
@@ -2684,5 +2659,5 @@
                   !!
                   !! total iron concentration (mmol Fe / m3 -> umol Fe / m3)
-                  xFeT        = zfer * 1.e3
+                  xFeT        = zfer(ji,jj) * 1.e3
                   !!
                   !! this has a base scavenging rate (12% / y) which is modified by local
@@ -2713,6 +2688,6 @@
                   !! by a magic factor, 0.002, to get it into nmol C / cm2 / s
                   !!
-                  fscal_part = ((xthetapn * zphn) + (xthetapd * zphd) + (xthetazmi * zzmi) + &
-                  (xthetazme * zzme) + (xthetad * zdet)) * 0.002
+                  fscal_part = ((xthetapn * zphn(ji,jj)) + (xthetapd * zphd(ji,jj)) + (xthetazmi * zzmi(ji,jj)) + &
+                  (xthetazme * zzme(ji,jj)) + (xthetad * zdet(ji,jj))) * 0.002
                   !!
                   !! calculate scaling factor for base scavenging rate
